%% Dbut du module echo_client2
-module(echo_client2).

-export([start/1, start/3]).

-define(defaultserver, localhost).
-define(defaultport, 9999).
-define(FREQ, 5000).  %% envoi un message toutes les 5 secondes

%% La fonction start/1 lance une connexion sur le serveur et le port
%% par dfaut.
%% Le paramtre nb_messages permet de dterminer le nombre de message
%% qui devront tre changs
start(Nb_Messages) ->
    start(Nb_Messages, ?defaultserver, ?defaultport).

%% La fonction start/2 lance une connexion sur le serveur et le port
%% passs en paramtres
start(Nb_Messages, Server, Port) ->
    %% [1] Lance la connexion sur le serveur
    Socket = case gen_tcp:connect(Server, Port, [{packet,0}, {active, true}, {reuseaddr, true}], infinity) of
                 {ok, Sock} -> Sock;
                 {error, Raison} -> io:format("Erreur de connexion: [~p]~n",
                                              [Raison]),
                                    exit(Raison)
             end,
    
    %% [2] Dialogue avec le serveur
    check_echo(Socket, Nb_Messages),
    
    %% [3] Se dconnecter du serveur
    gen_tcp:close(Socket).

%% Le processus d'cho se rpte jusqu' ce que tous les messages
%% aient t mis.
check_echo(Socket, 0) ->
    ok;
check_echo(Socket, Nb_Messages) ->
    Message = "Message n" ++ integer_to_list(Nb_Messages),
    gen_tcp:send(Socket, Message ++ "\r\n"),
    receive 
	{tcp, Socket, Donnees} -> 			
	    [Timestamp, Message_recu] = string:tokens(Donnees, "{},\"\r\n"),
	    io:format("Rception d'un cho: ~p = ~p~n",[Timestamp, Message_recu]),
	    %% Le client se plante si le message reu est diffrent de
	    %% celui envoy:
	    Message = Message_recu,
	    timer:sleep(?FREQ),
	    check_echo(Socket, Nb_Messages -1);
        Other -> {error, disconnected}
    end.
%% Fin du module echo_client2
