%% Dbut du module simple_client
-module(simple_client).

-export([start/0, start/2]).

-define(defaultserver, localhost).
-define(defaultport, 9999).

%% La fonction start/0 lance une connexion sur le serveur et le port
%% par dfaut
start() ->
    start(?defaultserver, ?defaultport).

%% La fonction start/2 lance une connexion sur le serveur et le port
%% passs en paramtres
start(Server, Port) ->
    %% [1] Lance la connexion sur le serveur
    Socket = case gen_tcp:connect(Server, Port, [], infinity) of
                 {ok, Sock} -> Sock;
                 {error, Raison} -> io:format("Erreur de connexion: [~p]~n",
                                              [Raison]),
                                    exit(Raison)
             end,
    
    %% [2] Envoi d'un message amical au serveur
    gen_tcp:send(Socket, "Bonjour, nous venons en paix !\n"),
    
    %% [3] Se dconnecter du serveur
    gen_tcp:close(Socket).
%% Fin du module simple_client
