%%%-------------------------------------------------------------------
%%% File    : ldap_proxy_app.erl
%%% Author  : Mickael Remond <mremond@mremond.cgey.ifp.fr>
%%% Description : 
%%%
%%% Created :  7 Mar 2003 by Mickael Remond <mremond@mremond.cgey.ifp.fr>
%%%-------------------------------------------------------------------
-module(ldap_proxy_app).

-behaviour(application).

%%--------------------------------------------------------------------
%% External exports
%%--------------------------------------------------------------------
-export([start/2, stop/1]).

%%
start(Type, []) ->
    %% Plugin initialisation
    %% Get module in charge of storing LDAP data that transit through the proxy
    Module    = ldap_proxy_config:proxy_handler(),
    ExtraArgs = ldap_proxy_config:extra_args(),
    Module:start(ExtraArgs),

    ldap_proxy_sup:start_link([]).

%%
stop(_State) ->
    %% Plugin shutdown
    Module    = ldap_proxy_config:proxy_handler(),
    ExtraArgs = ldap_proxy_config:extra_args(),
    Module:stop(ExtraArgs),

    _State.
