-module(texte_ui).
-compile(export_all).

start(NbCell, Generation, Matrice) ->
    io:format("Jeu de la vie en Erlang~n", []),
    loop(NbCell, Matrice, Generation, NbCell, []).

%% Cas particulier: On a reu toutes les cellules d'une gnration: On
%% affiche
loop(NbCell, Matrice, Generation, 0, Tampon) ->
    %% Affichage du rsultat  partir de tampon
    io:format("Generation ~p:~n",[Generation]),
    affiche(Matrice, Tampon),

    %% Nouvelle gnration
    loop(NbCell, Matrice, Generation + 1, NbCell, []);
loop(NbCell, Matrice, Generation, NbCellRestant, Tampon) ->
    receive
	%% Ne recoit que les cellules de gnration attendue
	{cellule, Coord, Generation, EtatCellule} ->
	    loop(NbCell, Matrice, Generation, NbCellRestant -1, [{Coord,EtatCellule}|Tampon])
    end.
    
affiche(Matrice = {X,Y}, Tampon) ->
    ToutesCellules = [ {I,J} || I <- lists:seq(1, X), J <- lists:seq(1, Y)],
    lists:foreach(fun(Cell = {A,B}) ->
			  {value, {Cell, Etat}} = lists:keysearch(Cell, 1, Tampon),
			  io:format("~c", [represente_cellule(Etat)]),
			  case B of
			      Y -> io:format("~n",[]);
			      Other -> ok
			  end
		  end,
		  ToutesCellules).


represente_cellule(alive) ->
    $+;
represente_cellule(dead) ->
    $..
