%% Protocol module
%% TODO: This should be put in a specific package later on

-module(connect).

-export([process/2]).

-include("rei.hrl").

process(_FromPid, Params) ->
    Params_list = rei_lib:parse_parameters(Params),

    Login = rei_lib:get_value(Params_list, "login", string),
    Password =rei_lib:get_value(Params_list, "password", string),

    LoginResult = mnesia_rei:check_user(Login, Password),

    process_login(LoginResult, Login, Password).

%% process_login(LoginResult, Login, Password)
%% If login is ok: Send the answer and then send the world description.
%% If user does not exist: create it and consider login is ok.
%% If password is incorrect send back an error.
%%% The first atom depend on the result of the function mnesia_rei:check_user/2
process_login(incorrect_user, Login, Password) ->
    mnesia_rei:create_user(Login, Password),
    {continue, ["INFO connect=ok created=true\r\n"] ++ send_world()};
process_login(incorrect_password, _Login, _Password) ->
    %% TODO: Use Error number like HTTP ?
    {continue, "ERROR incorrect password\r\n"};
process_login(ok, _Login, _Password) ->
    {continue, ["INFO connect=ok\r\n"] ++ send_world()}.
    %% Send back world information

%% Send the world description to the client
send_world() ->
    ListId = mnesia_rei:list_objects(),
    lists:map(fun(ObjectId) ->
		      Object = mnesia_rei:get_object(ObjectId),
		      {X, Y, Z} = Object#object.pos,
		      io_lib:format("INFO object id=~s class=~p pos=~f,~f,~f\r\n",
				    [Object#object.id,
				     Object#object.class,
				     X, Y, Z])
	      end, ListId).
