%% Protocol module
%% TODO: This should be put in a specific package later on
-module(new).

-export([process/2]).

process(FromPid, Params) ->
    Result = rei_lib:parse_parameters(Params),

    Id = rei_lib:get_value(Result,    "id"   , string),
    Class = rei_lib:get_value(Result, "class", atom),
    Pos = rei_lib:get_value(Result,   "pos",   pos),

    mnesia_rei:new_object(Id, Class, Pos),


    %% Notify all clients of the operation
    Message = rei_lib:notify_message(Id, Class, Pos),
    rei_server_notify_srv:notify(FromPid, Message),

    %% If we try to create an object with an existing Id, send back an
    %% error.
    %% Otherwise create the object.
    %% The test is not yet implemented.
    {continue, "INFO id=" ++ Id ++ " creation=ok\r\n"}.
