%% Protocol module
%% TODO: This should be put in a specific package later on
-module(update).

-export([process/2]).

-include("rei.hrl").

process(FromPid, Params) ->
    Params_list = rei_lib:parse_parameters(Params),

    Id = rei_lib:get_value(Params_list,    "id"   , string),
    Class = rei_lib:get_value(Params_list, "class", atom),
    Pos = rei_lib:get_value(Params_list,   "pos",   pos),

    mnesia_rei:update_object(Id, Class, Pos),

    %% Notify all clients of the operation
    Message = rei_lib:notify_message(Id, Class, Pos),
    rei_server_notify_srv:notify(FromPid, Message),

    %% If we try to update an objet that does not exist yet, send back an error
    %% Otherwise update the object.
    %% The test is not yet implemented.
    {continue, "INFO id=" ++ Id ++ " update=ok\r\n"}.
