-module(record3).

%% Fonction de cration (instanciation) de la structure
-export([creation_structure/4]).

%% Fonction d'affichage de la structure
-export([affiche_structure/1]).

%% Notre dfinition de structure
-record(individu, {nom, prenom, ville, telephone}).

%% La fonction d'instanciation de notre structure  partir des valeurs
%% passes en paramtre.
creation_structure(Nom, Prenom, Ville, Telephone) ->
    #individu{nom = Nom,
	      prenom = Prenom,
	      ville = Ville,
	      telephone = Telephone}.

%% Fonction d'affichage des informations contenus dans une structure
%% passe en paramtre
affiche_structure(Structure) ->
    Nom = Structure#individu.nom,
    Prenom = Structure#individu.prenom,    
    Ville = Structure#individu.ville,
    Telephone = Structure#individu.telephone,

    io:format("Nom: ~p~nPrnom: ~p~nVille: ~p~nTlphone: ~p~n",
	      [Nom, Prenom, Ville, Telephone]).

%% La compilation de la fonction suivante n'est pas possible:
%% Le champ fax n'existe pas:
% affiche_structure_erreur(Structure) ->
%     Nom = Structure#individu.nom,
%     Prenom = Structure#individu.prenom,    
%     Ville = Structure#individu.ville,
%     Fax = Structure#individu.fax,

%     io:format("Nom: ~p~nPrnom: ~p~nVille: ~p~nFax: ~p~n",
% 	      [Nom, Prenom, Ville, Fax]).
