-module(record4).

%% Fonctions de cration (instanciation de la structure)
-export([creation_structure/0, creation_structure/2]).

%% Fonction d'affichage de la structure
-export([affiche_structure/1]).

%% Notre dfinition de structure
-record(individu, {nom, prenom, ville, telephone}).

%% La fonction d'instanciation de notre structure sans dfinition de
%% champ (Sans valeur particulire)
creation_structure() ->
    #individu{}.

%% Fonction d'instanciation de notre structure en donnant la valeur de
%% deux champs
creation_structure(Nom, Prenom) ->
    #individu{nom = Nom, prenom = Prenom}.

%% Fonction d'affichage des informations contenus dans une structure
%% passe en paramtre
affiche_structure(Structure) ->
    Nom = Structure#individu.nom,
    Prenom = Structure#individu.prenom,    
    Ville = Structure#individu.ville,
    Telephone = Structure#individu.telephone,

    io:format("Nom: ~p~nPrnom: ~p~nVille: ~p~nTlphone: ~p~n",
	      [Nom, Prenom, Ville, Telephone]).
