-module(record6).

%% Fonctions de dmonstration de la modification de structures
-export([modif_structure/0]).

%% Fonction d'affichage de la structure
-export([affiche_structure/1]).

%% Notre dfinition de structure
-record(individu, {nom, prenom, ville = "Paris", telephone}).

%% La fonction d'instanciation de notre structure sans dfinition de
%% champ (Sans valeur particulire)
modif_structure() ->
    %% Cration et affichage de la premire structure:
    Individu1 = #individu{nom = "Rmond", prenom = "Mickal"},
    io:format(" -*- Premire structure -*-~n", []),
    affiche_structure(Individu1),
    
    %% Une deuxime structure est cr par modification de la
    %% prcdente
    Individu2 = Individu1#individu{telephone = "0122334455"},
    io:format(" -*- Deuxime structure -*-~n", []),
    affiche_structure(Individu2).

%% Fonction d'affichage des informations contenus dans une structure
%% passe en paramtre
affiche_structure(Structure) ->
    Nom = Structure#individu.nom,
    Prenom = Structure#individu.prenom,    
    Ville = Structure#individu.ville,
    Telephone = Structure#individu.telephone,

    io:format("Nom: ~p~nPrnom: ~p~nVille: ~p~nTlphone: ~p~n",
	      [Nom, Prenom, Ville, Telephone]).
