-module(deplacements).

-export([piece/2, can_pawn_jump/1]).

-include("chesslang.hrl").

%% Dplacement du pion
%% Le pion est blanc:
piece(Piece = {Case, Pion}, Echiquier)
  when abs(Pion) == ?pion,
       Pion > 0 ->
    ListePieces = Echiquier#echiquier.pieces,
    %% Traitement de l'avance du pion.
    Moves = case can_pawn_jump(Piece) of
		%% Si le pion se trouve sur sa case de dpart, deux mouvements sont possibles
		true -> filtre_mouvements_pion([Case - 10, Case - 20], ListePieces);
		%% S'il ne s'y trouve pas, un seul mouvement est possible.
		false -> filtre_mouvements_pion([Case - 10, Case - 20], ListePieces)
			 %% Traitement de la prise par le pion.
	    end;
%% Dplacement du cavalier
piece(Piece = {Case, ?cavalier}, Echiquier) ->
    deplacement_cavalier;
piece(Piece = {Case, - ?cavalier}, Echiquier) ->
    deplacement_cavalier.


%% Passage d'une fun d'avance pion ou de recul suivant le type:
filtre_mouvements_pion(Cases, ListePieces) ->
    filtre_mouvements_pion(Cases, ListePieces, []).
filtre_mouvements_pion([], _ListePieces, Resultat) ->
    lists:reverse(Resultat);
filtre_mouvements_pion([Case|Cases], ListePieces, Resultat) ->
    case lists:keymember(Case, 1, ListePieces) of
	true -> Resultat;
	false -> filtre_mouvements_pion(Cases, ListePieces, [Case|Resultat])
    end.

%% Le pion peut il avancer de deux case ?
%% Le pion est blanc
can_pawn_jump(Piece = {Case, Pion})
  when abs(Pion) == ?pion,
       Pion > 0 ->
    Case > 80;
%% Le pion est noir
can_pawn_jump(Piece = {Case, Pion})
  when abs(Pion) == ?pion,
       Pion < 0 ->
    Case < 40.
