-module(processus2).
-export([init/0, init/1, start/1, start1/0]).
-export([processus/1]).

%% Cre un nombre de processus dtermine  partir de la fonction
%% processus/1
init() ->
    init(10000).

init(NombreProcessus) ->
    %% Initialisation du gnrateur de nombre alatoire
    {N1,N2,N3} = now(),
    random:seed(N1,N2,N3),
    start(NombreProcessus),
    io:format("Nombre de processus sur ce noeud: ~w~n", [length(processes())]).

start(0) ->
    ok;
start(NombreProcessus) ->
    start1(),
    start(NombreProcessus - 1).

%% Cre un nouveau processus avec un dure de vie comprise entre
%% 90 et 180 secondes
start1() ->
    %% Initialisation du gnrateur de nombre alatoire
    {N1,N2,N3} = now(),
    random:seed(N1,N2,N3),
    
    %% Gnration de la dure du vie du processus
    DureeDeVie = random:uniform(90) + 90,

    %% Cration du nouveau processus
    spawn(?MODULE, processus, [DureeDeVie]).

%% Fonction servant de support  l'excution de notre nouveau processus
processus(DureeDeVie) ->
    %% timer:sleep accepte une valeur en millisecondes
    timer:sleep(DureeDeVie * 1000).
 
