-module(catch_piege).
-export([start1/0, start2/0]).

%% Attention, la fonction start2/0 place le systme dans une boucle infinie
%% Ce programme illustre l'impact d'une mauvaise comprhension de
%% l'interception des erreurs.
%% Ce programme est un mauvais exemple.

start1() ->
    Donnees = [{1, "Salarie 1"},
	       {2, "Salarie 2"}, 
	       {3, "Salarie 3"}],
    start(Donnees).

start2() ->
    Donnees = [{1, "Salarie 1"},
	       {2, "Salarie 2"}, 
	       {3, salarie3}],
    start(Donnees).

start(Donnees) ->
    %% remplissage de la table:
    Table = creation_table(Donnees),
    process_table(Table, nb_element(Table)).

%% Cre la table et la peuple avec les donnes passes en paramtre.
creation_table(Donnees) ->
    Table = ets:new(table, []),
    lists:foreach(fun(Ligne) ->
			  ets:insert(Table, Ligne) end,
		  Donnees),
    %% Renvoie l'identifiant de table pour manipulation dans le reste
    %% du programme
    Table.
 
%% Lorsque la table est vide, on sort de la boucle:
process_table(Table, 0) ->
    ok;
%% Si la table n'est pas vide, on effectue le traitement du premier lement
process_table(Table, NbElement) ->
    io:format("Encore ~w elements.~n", [NbElement]),

    %% Si le traitement d'un salarie est erron, on continue malgr
    %% tout jusqu' la fin de la table. Il s'agit d'appliquer le
    %% principe de mininimisation du traitement du code de gestion
    %% d'erreur: Si une erreur se produit on considre que le
    %% traitement sur le salarie n'avait pas d'objet, on passe alors
    %% au salari suivant.
    %% Si le principe est bon, le raisonnement est errone car si une
    %% erreur se produit dans la fonction traitement par exemple, le
    %% premier salari ne sera jamais supprim: On part alors dans un
    %% boucle infinie.
    catch process_ligne(Table),
    process_table(Table, nb_element(Table)).

nb_element(Table) ->
    ets:info(Table, size).

process_ligne(Table) ->
    Identifiant = ets:first(Table),
    [Salarie] = ets:lookup(Table, Identifiant),
    traitement(Salarie),
    ets:delete(Table, Identifiant).

%% Le traitement se contente ici d'afficher le nom du salarie.
%% Hypothse est faite que le nom du salari est une chaine de caractre
traitement(Salarie = {Identifiant, Nom}) ->
    %% Conversion de la chaine en majuscule avant affichage
    io:format("Traitement de: ~s~n", [httpd_util:to_upper(Nom)]).

