%% monitor - simple application monitor

-module(monitor). 
-export([start/3,run/3]). 
-define(max,5).

%% spawn of monitor process
start(Module, Function, Args) -> 
    spawn(?MODULE,run,[Module, Function, Args]).

%% start application being monitored with traps being caught
run(Module, Function, Args) -> 
    process_flag(trap_exit, true), 
    Child = spawn_link(Module,Function,Args),
    monitor(Child, ?max, Module, Function, Args).

%% wait for something to go wrong, log, restart application
monitor(Child, N, Module, Function, Args) -> 
    receive 
        {'EXIT', Child, normal} when N > 0 -> 
	    ok;
        {'EXIT', Child, Why} when N > 0 -> 
            io:format("~p:~p~p died ~p~n", [Module,Function,Args,Why]), 
            NewChild = spawn_link(Module,Function,Args),
            monitor(NewChild,N-1,Module,Function,Args); 
        {'EXIT', Child, _} -> 
            io:format('too many restarts on ~p:~p~p!~n', [Module,Function,Args])
    end. 
