-module(processus_sup1).
-export([start/0]).
-export([superviseur/0, erreur_apres/1]).

start() ->
    spawn(?MODULE, superviseur, []).

superviseur() ->
    %% Processus travailleur1
    Pid1 = spawn_link(timer, sleep, [60000]),
    io:format("Lancement du processus 1: ~p~n", [Pid1]),

    %% Processus travailleur2
    Pid2 = spawn_link(timer, sleep, [10000]),
    io:format("Lancement du processus 2: ~p~n", [Pid2]),

    %% Processus travailleur3
    Pid3 = spawn_link(?MODULE,erreur_apres, [30000]),
    io:format("Lancement du processus 3: ~p~n", [Pid3]),

    attend_indefiniment().

%% Gnre un erreur aprs un nombre de millisecondes passes en
%% paramtre
erreur_apres(Duree) ->
    timer:sleep(Duree),
    %% La ligne suivante provoque une erreur d'excution de type
    %% badmatch
    1 = 2.

attend_indefiniment() ->
    Ref = make_ref(),
    receive
        Ref ->
             ok
    end.


