-module(database).

-export([create/0, insert/0]).

-include("database.hrl").

%% Cree les tables dans la base de donnees courante
create() ->
    mnesia:start(),
    {atomic,ok} = mnesia:create_table(membre,
                        [{attributes, record_info(fields, membre)},
			 {disc_copies, [node()]}]),
    io:format("-*-*- La cration de la table \"membre\" s'est bien droule. -*-*-~n", []),
    mnesia:stop().

%% Insere le jeu de donnees initial
insert() ->
    insert("mikl", "Remond", "Mickael", "mickael.remond@erlang-fr.org", "France"),
    insert("francesco", "Cesarini", "Francesco", "francesco@erlang-consulting.com", "Royaume-Uni"),
    insert("thierry", "Mallard", "Thierry", "thierry.mallard@erlang-fr.org", "France").
		      
    

%% Insere un membre
insert(Pseudo, Nom, Prenom, Mail, Country) ->
    Membre = #membre{pseudo = Pseudo,
		     nom    = Nom,
		     prenom = Prenom,
		     mail   = Mail,
		     country= Country},
    Fun = fun() ->
		  mnesia:write(Membre)
	  end,
    {atomic, ok} = mnesia:transaction(Fun),
    ok.

