%% Dbut du module helloworld_tk
-module(helloworld_tk).

-export([start/0]).

start() ->
    %% Lancement du systme d'interface graphique
    Gs = gs:start(),

    %% Cration d'une fentre de 200 pixels de large et 100 pixel de haut.
    %% Cette fentre est l'objet principal de notre application graphique.
    Win = gs:create(window,Gs,[{width,200},{height,100}]),

    %% Cration d'un objet de type label dans la fentre Win permettant
    %% d'afficher du texte
    Label = gs:create(label, Win, [{label, {text, "Hello world!"}}]),
    
    %% La fentre reste invisible tant que la proprit de la fentre
    %% baptis map n'est pas positionn sur vrai.
    %% Affiche la fentre:
    gs:config(Win, {map,true}),
    
    %% La cration d'une boucle est indispensable car l'application ne
    %% fonctionne que tant que le processus qui contrle l'application
    %% reste vivant.
    loop().

%% Boucle traitant les vnements de l'application
%% Lorsqu'un vnement est reu en provenance de l'interface graphique,
%% on sort de la boucle.
loop() ->
    receive
        Evenement ->
            io:format("Un vnement a t reu: ~p~n", [Evenement])
    end.
%% Fin du module helloworld_tk
